org.apache.solr.client.solrj.io.stream

## Class LeftOuterJoinStream

- java.lang.Object
- - org.apache.solr.client.solrj.io.stream.TupleStream
  - - org.apache.solr.client.solrj.io.stream.JoinStream
    - - org.apache.solr.client.solrj.io.stream.BiJoinStream
      - - org.apache.solr.client.solrj.io.stream.LeftOuterJoinStream

All Implemented Interfaces:
  Closeable, Serializable, AutoCloseable, Expressible, MapSerializable, MapWriter

    public class LeftOuterJoinStream
    extends BiJoinStream
    implements Expressible

Joins leftStream with rightStream based on a Equalitor. Both streams must be sorted by the fields being joined on. Resulting stream is sorted by the equalitor.

Since:
  6.0.0
See Also:
  Serialized Form

### Nested Class Summary

### Nested classes/interfaces inherited from class org.apache.solr.client.solrj.io.stream.TupleStream

`TupleStream.IgnoreException`

### Nested classes/interfaces inherited from interface org.apache.solr.common.MapWriter

`MapWriter.EntryWriter`

### Field Summary

### Fields inherited from class org.apache.solr.client.solrj.io.stream.BiJoinStream

`iterationComparator, leftStream, leftStreamComparator, rightStream, rightStreamComparator`

### Fields inherited from class org.apache.solr.client.solrj.io.stream.JoinStream

`eq`

### Constructor Summary

Constructors
Constructor and Description
`LeftOuterJoinStream(StreamExpression expression, StreamFactory factory)`
`LeftOuterJoinStream(TupleStream leftStream, TupleStream rightStream, StreamEqualitor eq)`

### Method Summary

All Methods Instance Methods Concrete Methods
`StreamComparator` `getStreamSort()`
`Tuple` `read()`

### Methods inherited from class org.apache.solr.client.solrj.io.stream.BiJoinStream

`validateTupleOrder`

### Methods inherited from class org.apache.solr.client.solrj.io.stream.JoinStream

`children, close, getCost, getStream, isValidTupleOrder, loadEqualTupleGroup, open, setStreamContext, toExplanation, toExpression`

### Methods inherited from class org.apache.solr.client.solrj.io.stream.TupleStream

`getShards, getStreamNodeId, writeMap`

### Methods inherited from class java.lang.Object

`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

### Methods inherited from interface org.apache.solr.client.solrj.io.stream.expr.Expressible

`toExplanation, toExpression`

### Methods inherited from interface org.apache.solr.common.MapWriter

`toMap`

### Constructor Detail

#### LeftOuterJoinStream

    public LeftOuterJoinStream(TupleStream leftStream,
                               TupleStream rightStream,
                               StreamEqualitor eq)
                        throws IOException

Throws:
  `IOException`

#### LeftOuterJoinStream

    public LeftOuterJoinStream(StreamExpression expression,
                               StreamFactory factory)
                        throws IOException

Throws:
  `IOException`

### Method Detail

#### read

    public Tuple read()
               throws IOException

Specified by:
  `read` in class `TupleStream`
Throws:
  `IOException`

#### getStreamSort

    public StreamComparator getStreamSort()

Specified by:
  `getStreamSort` in class `TupleStream`